/*		reversi2.c

		7/18/86  m f davis
        12/94 reversi2 adapted from reversi1
        rules: move 1 (replicate) or 2 (move)
        hit space to indicate which x and where
        use arrow keys to move cursor '+'
*/
//#include "include.h"
#include <stdio.h>
#include <stdlib.h>  
#include <ctype.h>
#ifdef WIN32
#include "windows.h"
#endif

typedef char *string;


// #define Debug2 1

#define True	1
#define False	0
#define Size    7
#define Unoc 	0
#define Ucode	1
#define Mcode	2
#define Move	3
#define Nomv	4

#define Maxdepth 4      //  Max # moves lookahead, toggle with 'l'

#define iabs(x) ((x>0)?(x):-(x))

//#include "machine.h"
//#include "ctype.h"
static
int sizm1 = Size - 1, nuser, nmach, scorerow = 18, scorecol = 16,
	User = Ucode, Mach = Mcode,
	prt_flag = True, Maxlevel = Maxdepth, startlevel = 2,
	ndir = 10, bd_size, upcase_offset = 4,
	direction [10] [2] = {0, 0, -1, 1, 0, 1, 1, 1, -1, 0, 0, 0, 1, 0, 
				-1, -1, 0, -1, 1, -1},
	toprow = 4, restart = False, moves, quit, startrow = 5, startcol = 28;
static int row = 2, col = 2, selected = 0, select_row, select_col,
      move_type;
//char loread (), chrset [] = {".*Ox+"}, board [Size] [Size];
char loread (), chrset [] = {".xo*+XO"}, board [Size] [Size];
void init_board (void);
void display_board (void);
void machine_move (void);
void print_results (void);
void print_score (void);
int isnumber (char c);
void move_cursor (int *direction);
int find_best (int side, int level);
void restore (void);
int valid (int side);
int count_moves (int side);
void print_mesg (string s);
void make_move (int side);
void blockmv (string tmp_bd, string board, int bd_size);
int eval (int side);
void user_move (void);


#ifndef WIN32   
#include <dos.h>
#include <graph.h>  
union REGS inregs, outregs;
#endif


#ifndef WIN32

subint ()
{
	int86 (0x16, &inregs, &outregs);
	if (outregs.h.al) return (int) (0x7f & outregs.h.al);
	return (int) (0x80 | outregs.h.ah);
}


keychkc ()
{
//int i;
//	if (! kbhit ()) return 0;
	inregs.h.ah = 0x01;     
	return subint ();
}

#endif	//	!WIN32


#ifdef WIN32
#include "conio.h"

int chkkbd (void)
{
    return _kbhit ();
}


#else           /*      !WIN32	*/


chkkbd ()

/*        return the masked character if there is one, else zero       */
/*        do not cancel the flag            (microsoft compiler)       */

{
	return keychkc ();
}

#endif



#ifndef WIN32
void crt_mode (i)
int i;
{

    if (i < 256) {
        i &= 0x7f;
	if( !_setvideomode( i ) ) {
        printf ("\ncrt_mode: cannot set video mode %d      \n", i);
        exit (1);
        }

    return;
    }       /*      i < 256	*/
	inregs.x.ax = i;
	int86 (0x10, &inregs, &outregs);
}
#endif

#ifdef WIN32        /*      Console API	*/

/************************************************************************
* FUNCTION: cls(HANDLE hConsole)                                        *
*                                                                       *
* PURPOSE: clear the screen by filling it with blanks, then home cursor *
*                                                                       *
* INPUT: the console buffer to clear                                    *
*                                                                       *
* RETURNS: none                                                         *
*************************************************************************/

/********************************************************************
* FUNCTION: getConX(HANDLE hCon)                                    *
*                                                                   *
* PURPROSE: to get the current width of the console output buffer   *
*                                                                   *
* INPUT: the handle to get the information for                      *
*                                                                   *
* RETURNS: the width of the current console output buffer, in chars *
********************************************************************/

SHORT getConX(HANDLE hCon)
{
  CONSOLE_SCREEN_BUFFER_INFO csbi;
  BOOL bSuccess;

  bSuccess = GetConsoleScreenBufferInfo(hCon, &csbi);
/*  PERR(bSuccess, "GetConsoleScreenBufferInfo");	*/
  return(csbi.dwSize.X);
}


/*********************************************************************
* FUNCTION: getConY(HANDLE hCon)                                     *
*                                                                    *
* PURPROSE: to get the current height of the console output buffer   *
*                                                                    *
* INPUT: the handle to get the information for                       *
*                                                                    *
* RETURNS: the height of the current console output buffer, in chars *
*********************************************************************/


SHORT getConY(HANDLE hCon)
{
  CONSOLE_SCREEN_BUFFER_INFO csbi;
  BOOL bSuccess;

  bSuccess = GetConsoleScreenBufferInfo(hCon, &csbi);
/*  PERR(bSuccess, "GetConsoleScreenBufferInfo");	*/
  return(csbi.dwSize.Y);
}


void clr_scrn (void)
/* void cls(HANDLE hConsole)	*/
{
  COORD coordScreen = { 0, 0 }; /* here's where we'll home the cursor */
  BOOL bSuccess;
  DWORD cCharsWritten;
  HANDLE hConsole;


    hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
  /* fill the entire screen with blanks */
  bSuccess = FillConsoleOutputCharacter(hConsole, (TCHAR) ' ',
      getConX(hConsole) * getConY(hConsole), coordScreen, &cCharsWritten);
/*  PERR(bSuccess, "FillConsoleOutputCharacter");	*/
  /* put the cursor at (0, 0) */
  bSuccess = SetConsoleCursorPosition(hConsole, coordScreen);
/*  PERR(bSuccess, "SetConsoleCursorPosition");	*/
/*  return;	*/
}


#else               /*      !WIN32	*/

//int gradapter, 
int default_txmode = 3;
//unsigned iTxPageSeg;

void clr_scrn (void)
{

		crt_mode (default_txmode);		/*		2		*/
}
#endif      /*      (!)WIN32	*/

/*      sleep i msec	*/

#ifdef WIN32

void sleep (i)
int i;
{
    Sleep (i);
}

#else

#include "sys\types.h"
#include "sys\timeb.h"


void sleep (i)
int i;		/*		msec		*/
{
static struct timeb start, stop;
static long li, strt, stp;
	li = i;
	ftime (&start);
	strt = li + start.millitm + (long) 1000 * start.time;
	while (1) {
		ftime (&stop);
		stp = stop.millitm + (long) 1000 * stop.time;
		if (stp >= strt) return;
		}
}
#endif

      



#ifdef WIN32
//#include <conio.h>

static int isValidKey( pInputBuffer )
PINPUT_RECORD pInputBuffer;
  {
  int retc = 0;

  if(
    pInputBuffer->EventType == KEY_EVENT
    &&
    pInputBuffer->Event.KeyEvent.bKeyDown
    &&(
      pInputBuffer->Event.KeyEvent.uChar.AsciiChar
      ||
      pInputBuffer->Event.KeyEvent.wVirtualKeyCode < 16
      ||
      pInputBuffer->Event.KeyEvent.wVirtualKeyCode > 18
      )
    )
    retc = 1;

  return( retc );
  }




keygetc ()
{
static int i;
//extern int ctrlcflag;

//	if (ctrlcflag) {
//		ctrlcflag = 0;
//		return 3;
//		}
    while (! chkkbd ()) {
//#ifndef Usethread
 //       winio_yield ();
//#endif
//        if (chInpeek ()) {
//            return chInput ();
//            }
//..	    if (ctrlcflag) {
//		    ctrlcflag = 0;
//	    	return 3;
 //   		}
        sleep (50);
        }
	if (! (i = _getch ())) return 128 | _getch ();
	return i;
}

#else

#include "dos.h"

//static union REGS inregs, outregs;
#define ZF 0x01		/*		mask to get zf bit from cflag	*/

keygetc ()
{
	inregs.x.ax = 0x00;     
	return subint ();
}

#endif		/*		(ndef) WIN32	*/


kread ()

/*        read a char from kb without echo                 */
{

	return keygetc ();		
}


      

	
void longpaus (void) {
#ifdef Debug2
    if ('q' == kread ()) exit (1);
#else
      sleep (1000);
#endif
}


 
/*
 *   Move the cursor to the appropriate position.
 */

void mv_curs (int c, int r)
{
static char buf [4];

#ifdef WIN32
{
static HANDLE hcons = 0;
static COORD coordCursor;

    if (! hcons) {
    if (! (hcons = GetStdHandle(STD_OUTPUT_HANDLE))) {
        printf ("mv_curs: cannot get console input handle\n");
        kread ();
        return;
        }
    }

        coordCursor.X = c;
        coordCursor.Y = r;
        SetConsoleCursorPosition (hcons, coordCursor);
}

#else               /*      !WIN32	*/


     /* locate cursor to r, c;        */
{
static union REGS inregs, outregs;


	inregs.h.ah = 0x0f;		/*		get mode int 10 function		*/
	int86 (0x10, &inregs, &inregs);		/*	current page	*/
     inregs.x.ax = 0x200;     
     inregs.h.dh = r;
     inregs.h.dl = c;
     int86 (0x10, &inregs, &outregs);
}
#endif              /*      (!)WIN32	*/
}

             
             
             
void main ()
{
#ifdef Mainframe
	initscr ();
#endif
	clr_scrn ();
	bd_size = Size * Size;
newgame:
	init_board ();
	display_board ();
	while (moves = (bd_size - (nuser + nmach))) {
		do {user_move ();} while (restart);
		if (quit) break;
        longpaus ();
		if (moves) {
            machine_move ();
            longpaus ();
            }
		}
	print_results ();
	if (restart) goto newgame;
	exit (0);
}


void init_board (void)
{
int i, j;
	for (i = 0; i < Size; i++) {
		for (j = 0; j < Size; j++) 
			board [i] [j] = Unoc;
		}
	board [0] [0] = User;
	board [sizm1] [sizm1] = User;
	board [sizm1] [0] = Mach;
	board [0] [sizm1] = Mach;
	moves = Size * Size - 4;
//	row = 2;
//	col = 2;
	board [row] [col] = Nomv;
	nuser = 2;
	nmach = 2;
	quit = False;
	restart = False;
}


void display_board (void)
{
int i, j, r, c;
/*	printf ("Display bd chrset =%c %c %c %c \n",
	*chrset, *(1+chrset), *(2+chrset), *(3+chrset));		*/
	r = startrow;
	c = startcol;
	for (i = 0; i < Size; i++) {
		mv_curs (c, r++);
		for (j = 0; j < Size; j++) {
			putchar (chrset [board [i] [j]]);			
			putchar (' ');
			}
		}
	print_score ();
}


void user_move (void)
{
char str [80], c;
int i;
	
	restart = False;
	if (! count_moves (User)) {
        print_mesg ("User passes");
        return;}
	while (True) {
		c = loread ();
		if (isnumber (c)) {
			i = c - '0';
			move_cursor (&(direction [i] [0]));
			}
	else {
		switch (c) {
        case ' ':
			i = board [row] [col];
            if (selected) {
                if (row == select_row && col == select_col) {
                    board [row] [col] = User;
                    putchar (chrset [board [row] [col]]);
                    restore ();
                    }   //  row/col equal
                else {
        			if (valid (User)) {
    		    		make_move (User);
	    		    	return;
                        }
                    else {
        				print_mesg ("     Not a valid move");
	        			break;
                        }
                    }   //  row/col unequal

                }       //  selected
            else {      //  !selected
	     		if ((i == Nomv) || (i == Move) || (i == Mach)) {
    				print_mesg ("     Not a valid selection");
	    			break;
                    }
                putchar (chrset [(board [row] [col] = User) + upcase_offset]);
                select_row = row;
                select_col = col;
                restore ();
                }       //  (!)selected


            selected = !selected;
            break;

		case '\010':
		case 'h':       //      hint
			i = board [row] [col];
			if ((i == Nomv) || (i == Move)) {
				board [row] [col] = (char) Unoc;
				putchar (chrset [Unoc]);
#ifdef Mainframe
	putchar ((char) 8);
#endif
				}
			find_best (User, startlevel);
			restore ();
			i = board [row] [col];
			if (i == Unoc) {
				board [row] [col] = i = Nomv - valid (User);
				putchar (chrset [i]);
#ifdef Mainframe
	putchar ((char) 8);
#endif
				restore ();
				}
			break;
		case 'p':       //      pass
			if (count_moves (User)) {
				print_mesg ("   Must make available move");
				break;
				}
			else {
				print_mesg ("        User passes");
				return;
				}
		case 's':
			print_mesg ("         Switch sides");
			i = User;
			User = Mach;
			Mach = i;
			i = nuser;
			nuser = nmach;
			nmach = i;
			return;
		case 'q': 
			print_mesg ("              Quit");
			moves = 0;
			quit = True;
			return;
		case 'l':
			sprintf (str, "             Current skill level: %d", startlevel);
			print_mesg (str);
			startlevel--;
			if (startlevel < 0) startlevel = Maxlevel;
			sprintf (str, "             New skill level: %d", startlevel);
			print_mesg (str);
			break;
		case '?':
		print_mesg ("q(uit  l(evel  n(ewgame  ' ': move  h(elpmove  p(ass");
		print_mesg ("s(witch sides                                       ");
			break;
		case 'n': 
			print_mesg ("            New game");
			init_board ();
			display_board ();
			restart = True;
			return;
/*
		case ' ': 
			if (valid (User)) {
				make_move (User);
				return;
				}
			else {
				print_mesg ("     Not a valid move");
				break;
				}
*/
		}		/*		switch (c)			*/
		}		/*		end else not number	*/
	}			/*		while True			*/
}


void print_results (void)
{
char c;
	mv_curs (scorecol, toprow);
	if (nuser == nmach) 
		printf ("          Tie Game!");
	else if (nuser > nmach) 
		printf ("        You win by %d!", nuser - nmach);
	else
		printf ("        I win by %d!", nmach - nuser);
	restore ();
	longpaus ();
	mv_curs (scorecol, toprow);
	printf ("           New game?                ");
	restore ();
	c = loread ();
	restart = (c == 'y');
	mv_curs (scorecol, toprow);
	printf ("                                   ");
	if (restart) restore ();
	else mv_curs (0, 23);
}


char loread ()
{
unsigned char c;
#ifdef Mainframe
	c = 0x7f & kread ();
	putchar ((char) 8);
	putchar (chrset [board [row] [col]]);
	putchar ((char) 8);
#endif  //  Mainframe

    c = kread ();
tragn:
    switch (c) {
        case 199:
            c = '7';
            break;
        case 200:
            c = '8';
            break;
        case 201:
            c = '9';
            break;
        case 203:
            c = '4';
            break;
        case 205:
            c = '6';
            break;
        case 207:
            c = '1';
            break;
        case 208:
            c = '2';
            break;
        case 209:
            c = '3';
            break;
        case 224:
            c = 128 | kread ();
            goto tragn;
            break;
        default:
            c = c & 0x7f;
            break;
        }   //  switch c
	if (isupper (c)) c = tolower (c);
	return c;
}	
      

void print_score (void)
{
	mv_curs (scorecol, scorerow);
	printf ("User: %d      Machine: %d     Diff: %d                   ", 
		nuser, nmach, nuser - nmach);
	restore ();
}


void print_mesg (string s)
//char *s;
{
		mv_curs (scorecol, scorerow);
		printf ("%s                                    ", s);
		restore ();
//		if (! chkkbd ())
            longpaus ();
#ifdef Debug
//        longpaus (); longpaus ();
#endif  //  Debug
		print_score ();
}


void move_cursor (int *direction)
//int *direction;
{
//int i, j, k;
int i;

	i = board [row] [col];
	if ((i == Nomv) || (i == Move)) {
		board [row] [col] = (char) Unoc;
		putchar (chrset [Unoc]);
#ifdef Mainframe
	putchar ((char) 8);
#endif
		}
	col += *(direction++);
	row += *direction;
	if (col < 0) col = sizm1;
	if (col > sizm1) col = 0;
	if (row < 0) row = sizm1;
	if (row > sizm1) row = 0;
	restore ();         //  mv cursor
	i = board [row] [col];
	if (i == Unoc) {
		board [row] [col] = i = Nomv - valid (User);
		putchar (chrset [i]);
#ifdef Mainframe
	putchar ((char) 8);
#endif
		restore ();
		}
}
	


int valid (int side)
//int side;
{
int i, dir;
//int foundother, i, j, otherside;
//register int dir, *dirptr, r, c, dr, dc;

    if (!selected) return False;
	i = board [row] [col];
	if ((i == User) || (i == Mach)) return False;

/*	it's unoccupied		*/

//	if (side == User) otherside = Mach;
//	else otherside = User;

//  See if current row/col is within 1 of selected row/col
    move_type = iabs (row - select_row);
    dir = iabs (col - select_col);
    if (dir > move_type) move_type = dir;
    return (move_type < 3);

#ifdef Obs

/*	look in all directions			*/

	for (dir = 0, dirptr = (int *) direction; dir < ndir; dir++) {
		dc = *dirptr++;
		dr = *dirptr++;
		foundother = False;
		r = row;
		c = col;
		while (True) {
			r += dr;
			c += dc;
			if ((r < 0) || (c < 0) || (r > sizm1) || (c > sizm1)) break;
			j = board [r] [c];
			if (foundother) {
				if (j == side) return True;
				if (j == otherside) continue;
				break;
				}
			else {
				if (j == otherside) {
					foundother = True;
					continue;
					}
				break;
				}
			}		/*		while True (continue in direction		*/
		}		/*		dir loop			*/

	return False;

#endif  //  Obs

}




int exist_valid (int side)      //  valid move for this row/col?
//  Only has to return t/f
//int side;
{
int count, oldr, oldc, oldselected = selected;
int oldselect_row = select_row, oldselect_col = select_col;

	oldr = row;
	oldc = col;
	count = 0;
    selected = True;
    select_row = row;
    select_col = col;

//	for (select_row = 0; select_row < Size; select_row++) {
//		for (select_col = 0; select_col < Size; select_col++) {
            if (board [select_row] [select_col] != side) goto onout;
            for (row = 0; row < Size; row++) {
                for (col = 0; col < Size; col++) {
                    if (count += valid (side)) {
                    	row = oldr;
                       	col = oldc;
                        selected = oldselected;
                        select_row = oldselect_row;
                        select_col = oldselect_col;
                      	return count;
                        }   //  if count
                    }   //  col
                }   //  row
onout:
//          }   //  select_col
//      }   //  select_row




//			count += valid (side);
//            }
//		}
	row = oldr;
	col = oldc;
    selected = oldselected;
    select_row = oldselect_row;
    select_col = oldselect_col;
	return count;
}







int count_moves (int side)
//  Only has to return t/f
//int side;
{
int count, oldr, oldc, oldselected = selected;
int oldselect_row = select_row, oldselect_col = select_col;

	oldr = row;
	oldc = col;
	count = 0;
    selected = True;
	for (select_row = 0; select_row < Size; select_row++) {
		for (select_col = 0; select_col < Size; select_col++) {
            if (board [select_row] [select_col] != side) continue;
            for (row = 0; row < Size; row++) {
                for (col = 0; col < Size; col++) {
                    if (count += valid (side)) {
                    	row = oldr;
                       	col = oldc;
                        selected = oldselected;
                        select_row = oldselect_row;
                        select_col = oldselect_col;
                      	return count;
                        }   //  if count
                    }   //  col
                }   //  row
            }   //  select_col
        }   //  select_row




//			count += valid (side);
//            }
//		}
	row = oldr;
	col = oldc;
    selected = oldselected;
    select_row = oldselect_row;
    select_col = oldselect_col;
	return count;
}


int isnumber (char c)
//char c;
{
	return ((c >= '0') && (c <= '9'));
}

void restore (void)
{
	mv_curs (startcol + (col << 1), startrow + row);
}



void inc_score (side) {
	if (side == User) {
		nuser++;	}
	else {nmach++;	}
}

void dec_score (side) {
	if (side == User) {
		nuser--;	}
	else {nmach--;	}
}


void incdec_score (side) {
	if (side == User) {
		nuser++;	nmach--;}
	else {nuser--;	nmach++;}
}



void make_move (int side)
//int side;

/*	move known to be valid		*/

{
int r1, c1,
	cn, j, otherside;
//n, foundother, i, j, otherside;
register int dir, *dirptr, r, c, dr, dc;

	if (side == User) otherside = Mach;
	else otherside = User;

    if (prt_flag) {
        putchar (chrset [board [row] [col] =  side]);
        restore ();
        }
    else board [row] [col] = side;
    r1 = row;
    c1 = col;
    inc_score (side);

/*	look in all directions			*/

	for (dir = 0, dirptr = (int *) direction; dir < ndir; dir++) {
		dc = *dirptr++;
		dr = *dirptr++;
//		foundother = False;
		r = row;
		c = col;
		cn = 0;
//		while (True) {
			r += dr;
			c += dc;
			if ((r < 0) || (c < 0) || (r > sizm1) || (c > sizm1)) continue;
			j = board [r] [c];
#ifdef Obs
			if (foundother) {
				if (j == side) {
					r1 = row;
					c1 = col;
					for (k = 0; k < cn; k++) {
						r1 += dr;	c1 += dc;
						board [r1] [c1] = side;
					  if (prt_flag) {
							mv_curs (startcol + (c1 << 1), 
							startrow + r1);
						putchar (chrset [side]);
#ifdef Mainframe
	putchar ((char) 8);
#endif
						}
						if (side == User) {
							nuser++;	nmach--;}
						else {nuser--;	nmach++;}
						}		/*		k loop		*/
					break;
					}		/*		if j == side		*/

				if (j == otherside) {cn++; continue;}
				break;
				}		/*		if foundother		*/
			else {
#endif  //  Obs

				if (j == otherside) {
                    if (prt_flag) {
                        row = r;
                        col = c;
                        restore ();
                        putchar (chrset [board [r] [c] = side]);
                        row = r1;
                        col = c1;
                        }
                    else board [r] [c] = side;
                    incdec_score (side);
                    }


//					foundother = True;
//					cn++;
//					continue;
//					}		/*		if j == otherside		*/
//				break;
//				}		/*		else (if ! foundother)		*/

//			}		/*		while True (continue in direction)		*/
		}		/*		dir loop			*/

    row = select_row;
    col = select_col;
    if (move_type > 1) {
        j = Unoc;
        dec_score (side);
        }
    else {
        j = side;
        moves--;
        }
	if (prt_flag) {
        restore ();
        putchar (chrset [board [row] [col] = j]);
        }
    else board [row] [col] = j;
    selected = False;
    row = r1;
    col = c1;
  if (prt_flag) {
	restore ();
//	putchar (chrset [side]);
#ifdef Mainframe
	putchar ((char) 8);
#endif
//	moves--;
	}
//	if (side == User) nuser++;
//	else nmach++;
	if (prt_flag) print_score ();
}

#ifdef Debug
void prc (void) {
    mv_curs (0, 0);
    printf ("Row %d  Col %d  Select_row %d  Select_col %d\n",
        row, col, select_row, select_col);
    longpaus ();
//    longpaus ();
//    longpaus ();
    restore ();
}
#endif  //  Debug


void machine_move (void)
{
int r, c;

/*	mv_curs (scorecol, scorerow);
	printf ("       Working                    ");
	restore ();
*/
	if (startlevel == Maxlevel) {
	mv_curs (scorecol + 12, scorerow + 1);
	printf ("           hmm            ");
	restore ();
		}
	if (! count_moves (Mach)) {print_mesg ("Machine passes"); goto mout;}
	r = row; c = col;
	find_best (Mach, startlevel);

#ifdef Debug2
{char str [256];
    sprintf (str, "machine_move from find_best r %d  s %d  sr %d  sc %d  sl %d",
        row, col, select_row, select_col, selected);
    print_mesg (str);
//  print_mesg ("machine_move from find_best "); prc ();
}
#endif  //  Debug

    selected = True;
    valid (Mach);       //  get move_type
{int r = row, c = col;
    row = select_row;
    col = select_col;
    restore ();
    putchar (chrset [upcase_offset + board [row] [col]]);
    restore ();
    longpaus ();
    row = r;
    col = c;
    restore ();
}
	make_move (Mach);
	row = r;
	col = c;
mout:
	if (startlevel == Maxlevel) {
	mv_curs (scorecol + 12, scorerow + 1);
	printf ("                                  ");
	}
	restore ();
}


int find_best (int side, int level)
//  must return row, col, select_row, select_col; and set selected True
//int side, level;
{
int i, oldr, oldc, oldnu, oldnm, diff, best, bestr, bestc, otherside;
int old_sr = select_row, old_sc = select_col, old_selected = selected;
int bestsr, bestsc;
char tmp_bd [Size] [Size];

	if (side == User) otherside = Mach;
	else otherside = User;
	blockmv ((string) &tmp_bd, 
		(string) &board, bd_size);
	oldnu = nuser;
	oldnm = nmach;
	oldr = row;
	oldc = col;
	best = -999;
	prt_flag = False;
    selected = True;

#ifdef Debug
{char str [256];
    sprintf (str, "find_best side %d  level %d\n", side, level);
    print_mesg (str);
}
#endif  //  Debug


	for (select_row = 0; select_row < Size; select_row++) {
		for (select_col = 0; select_col < Size; select_col++) {

#ifdef Debug
{char str [256];
    sprintf (str, "find_best side %d  level %d  sr %d  sc %d bd %d  sel %d        \n",
        side, level, select_row, select_col, board [select_row] [select_col],
        selected);
    print_mesg (str);
}
#endif  //  Debug


            if (board [select_row] [select_col] != side) continue;
        	for (row = 0; row < Size; row++) {
		        for (col = 0; col < Size; col++) {
                    selected = True;
#ifdef Debug1
{char str [256];
                    sprintf (str, "find best lvl %d check valid  sel %d",
                        level, selected);
                    print_mesg (str);
                    prc ();
}
#endif  //  Debug
        			if (valid (side)) {
#ifdef Debug1
                        print_mesg ("Valid  ");
#endif  //  Debug
    		    		diff = eval (side);
	    		    	if (level) {    //  recursive call
		        			i = find_best (otherside, level - 1);
				        	if (i > -999) diff -= i;
        					}
		        		blockmv ((string) &board, (string) &tmp_bd, bd_size);
        				nuser = oldnu;
		        		nmach = oldnm;
        				if (diff > best) {
		        			best = diff;
        					bestr = row;
        					bestc = col;
                            bestsr = select_row;
                            bestsc = select_col;
		        			}
        				}		/*		if valid		*/
#ifdef Debug1
                    else {
                        print_mesg ("Not valid ");
                        }
#endif  //  Debug
		        	}			/*		for col			*/
        		}				/*		for row			*/
            }   //  select_col
        }   //  select_row
    selected = old_selected;
	if (level == startlevel) {
		prt_flag = True;
#ifdef Debug2
{char str [256];
        sprintf (str, "find best %d  lvl %d  r %d  c %d  sr %d  sc %d",
            best,
            level,
            bestr,
            bestc,
            bestsr,
            bestsc);
        print_mesg (str);
}
#endif  //  Debug

		if (best > -999) {
//          row = bestsr;
//          col = bestsc;
//          restore ();
			row = bestr;
			col = bestc;
            select_row = bestsr;
            select_col = bestsc;
			}
		else {
//          row = old_sr;
//          col = old_sc;
//          restore ();
			row = oldr;
			col = oldc;
            select_row = old_sr;
            select_col = old_sc;
			}
        restore ();
		return best;
		}				/*		if level == startlevel		*/
	else {
		row = oldr;
		col = oldc;	
        select_row = old_sr;
        select_col = old_sc;
		return best;
		}
}


int eval (int side)
//int side;

/*		evaluate the net gain/loss to side of making move at row, col,
        select_row, select_col
		move already known to be valid
*/

{
int diff, newdiff;

	if (side == User) {
		diff = nuser - nmach;
		make_move (side);
		newdiff = nuser - nmach - diff;
#ifdef Debug
{
char str [256];
        sprintf (str, "eval: User newdiff %d   Diff %d  Nmach %d  Nu %d",
            newdiff, diff, nmach, nuser);
        print_mesg (str);
        prc ();
}
#endif  //  Debug
		return newdiff;
		}
	else {
		diff = nmach - nuser;
		make_move (side);
		newdiff = nmach - nuser - diff;
#ifdef Debug
{
char str [256];
        sprintf (str, "eval: Mach newdiff %d   Diff %d  Nmach %d  Nu %d",
            newdiff, diff, nmach, nuser);
        print_mesg (str);
        prc ();
}
#endif  //  Debug
		return newdiff;
		}
}
		

void blockmv (string tmp_bd, string board, int bd_size)
//char *tmp_bd, *board;
//int bd_size;
{
	while (bd_size--) *tmp_bd++ = *board++;
}
